<template>
  <div>
    <Header :loggedIn="loggedIn" :auth="auth">
      <h1 class="header--hero--title">Blog</h1>
    </Header>
    <Container>
      <BlogArticlesList v-if="articles && articles.length && !loading" :articles="articles" />
      <Pagination v-if="articles && articles.length && !loading" :currentPage="currentPage" :totalPages="totalPages" @next="nextPage" @prev="prevPage" @setPage="setPage" />
      <div v-if="(!articles || !articles.length) && !loading">
        No Article Exists
      </div>
      <div v-if="loading">
        Loading...
      </div>
    </Container>
  </div>
</template>

<script>
import Header from '../components/Header';
import AC_Blog from "../lib/blog";
import BlogArticlesList from '../components/BlogArticlesList';
import Pagination from '../components/Pagination';
import Container from '../components/Container';

let blog = new AC_Blog();
export default {
  name: "blog",
  components: {
    Header,
    Container,
    BlogArticlesList,
    Pagination
  },
  props: ['auth'],
  data: function(){
    return {
      articles: [],
      articlesCount: undefined,
      articlePerPage: undefined,
      loading: false,
      loggedIn: (this.auth.currentUser ? true : false)
    }
  },
  methods: {
    nextPage: function(){

    },
    prevPage: function(){

    },
    setPage: function(){

    },
    getArticles: function(){
      this.loading = true;
      let page = this.currentPage;
      blog
        .getArticles({ page })
        .then(result => {
          this.loading = false;
          this.articles = result.articles;
          this.articlesCount = result.articlesCount;
          this.articlePerPage = result.perPage;
        })
        .catch(err => {
          this.loading = false;
        });
    }
  },
  computed: {
    currentPage: function(){
      return this.$route.query.page || 1;
    },
    totalPages: function(){
      if(this.articlesCount && this.articlePerPage){
        return Math.ceil(this.articlesCount/this.articlePerPage);
      } else {
        return undefined;
      }
    }
  },
  mounted: function(){
    this.getArticles();
  },
  watch: {
    $route: 'getArticles'
  }
};
</script>

<style>
</style>